#include <stdio.h>
#include <stdlib.h>

#include "sboxes.h"

extern void s1(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);
extern void s2(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);
extern void s3(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);
extern void s4(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);
extern void s5(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);
extern void s6(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);
extern void s7(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);
extern void s8(int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3);

void call_sx(int sboxidx, int i0, int i1, int i2, int i3, int i4, int i5,
	int *o0, int *o1, int *o2, int *o3)
{
    switch (sboxidx) {
	case 0: s1(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	case 1: s2(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	case 2: s3(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	case 3: s4(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	case 4: s5(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	case 5: s6(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	case 6: s7(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	case 7: s8(i0, i1, i2, i3, i4, i5, o0, o1, o2, o3); break;
	default: fprintf(stderr, "invalid S-box number: %i\n", sboxidx + 1);
		 exit(1);
    }
}

void validate_sbox(int sboxidx)
{
    int input;
    int i0, i1, i2, i3, i4, i5;
    int o0, o1, o2, o3;
    int res_bitslice;
    int res_official;
    for (input = 0; input < 64; input++)
      {
	i0 = !!(input & (1<<0));
	i1 = !!(input & (1<<1));
	i2 = !!(input & (1<<2));
	i3 = !!(input & (1<<3));
	i4 = !!(input & (1<<4));
	i5 = !!(input & (1<<5));
	o0 = o1 = o2 = o3 = 0;
	call_sx(sboxidx, i0, i1, i2, i3, i4, i5, &o0, &o1, &o2, &o3);
	res_bitslice =
	    ((o0 & 1) << 0) |
	    ((o1 & 1) << 1) |
	    ((o2 & 1) << 2) |
	    ((o3 & 1) << 3);
	res_official = sboxes[sboxidx][input];
	if (res_bitslice != res_official)
	  {
	    fprintf(stderr, "S-box %i, input %02x output %02x "
		    "(expected %02x)\n", sboxidx + 1, input,
		    res_bitslice, res_official);
	    //exit(1);
	  }
      }
}

int main(int argc, char **argv)
{
    (void)argc;
    (void)argv;
    for (int sboxidx = 0; sboxidx < 8; sboxidx++)
      {
	printf("Validating S-box %i\n", sboxidx + 1);
	validate_sbox(sboxidx);
      }
    return 0;
}
